
theory Interflang imports Tp Clocklang

begin

(*
datatype io
  = In|Out

record 'n inter_typ = 
    Typ::tp
    ClockTyp:: "('n,affset_tp) clexpr"   (* affset_tp*)
    Io :: io 
*)


(*
datatype 'n inter_typ = InterTyp "(val_tp)" "(('n,affset_tp) clexpr)"
*)

datatype 'c inter_typ = InterTyp "(val_tp)" 'c

fun get_inter_typ_valtp :: "'c inter_typ \<Rightarrow> val_tp "
where "get_inter_typ_valtp (InterTyp vt ct) = vt"

fun get_inter_typ_clocktp :: "'c inter_typ \<Rightarrow> 'c"
where "get_inter_typ_clocktp (InterTyp vt ct) = ct"


datatype ('n,'tp) var_types = VarTypes 'n 'tp

fun get_var_types_name :: "('n,'tp) var_types \<Rightarrow> 'n"
where "get_var_types_name (VarTypes a b) = a"

fun get_var_types_type :: "('n,'tp) var_types \<Rightarrow> 'tp"
where "get_var_types_type (VarTypes a b) = b"


datatype ('n,'tp) interf 
  = Interf "'n" "(('n,'tp) var_types list)"

fun get_interf_name :: "('n,'tp) interf \<Rightarrow> 'n"
  where "get_interf_name (Interf n tps) = n"

fun get_interf_types :: "('n,'tp) interf \<Rightarrow> ('n,'tp) var_types list"
  where "get_interf_types (Interf n tps) = tps"

type_synonym ('n,'v,'tp) interf_env 
  = "'n \<Rightarrow> ('n,'tp) interf option"

definition
  constr_interf_env :: "('n,'tp) interf list \<Rightarrow> ('n,'v,'tp) interf_env"
where  "constr_interf_env interfs \<equiv> map_of (map (\<lambda> i. (get_interf_name i, i)) interfs)"


fun wf_interf :: "('n, 'tp) interf \<Rightarrow> bool"
where "wf_interf (Interf n tps) = distinct (map get_var_types_name tps)"

end