
theory External imports Canonlang

begin

datatype ('n,'v,'tp) canon_proc_ext
  = CanProcExt  "('n proc_header)"  "(('n,'v,'tp) canon_stmt)"


datatype ('n,'v,'tp) canon_program_ext
  = CanProgramExt  "(('n,'tp) interf list)" "(('n,'v,'tp) canon_proc_ext list)" "('n,'v,'tp) canon_stmt"

fun get_canon_proc_ext_interf_name
where "get_canon_proc_ext_interf_name (CanProcExt (ProcHeader pintn pimpl) bd) = pintn"


fun
  wf_canon_program_ext :: "('n, 'v, 'tp) canon_program_ext \<Rightarrow> bool"
where
  "wf_canon_program_ext (CanProgramExt interfs procs c) =
  (distinct (map get_interf_name interfs)
  \<and> list_all wf_interf interfs
  \<and> list_subset (map get_canon_proc_ext_interf_name procs) (map get_interf_name interfs))"

fun constr_canon_program ::  "('n, 'v, 'tp) canon_program_ext \<Rightarrow> ('n, 'v, 'tp) canon_program" where
 "constr_canon_program (CanProgramExt interfs procs c) =
  (let ienv = constr_interf_env interfs in
    CanProgram 
       (map (\<lambda> pe. case pe of (CanProcExt ph bd) \<Rightarrow> 
                   CanProc ph (get_interf_types (the (ienv (get_proc_interf_name ph)))) bd) procs)
       c)"


end

